"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var operators_1 = require("rxjs/operators");
var keyHasType = function (type, key) {
    return type === key || (typeof key === 'function' && type === key.toString());
};
/**
 * Inferring the types of this is a bit challenging, and only works in newer
 * versions of TypeScript.
 *
 * @param ...types One or more Redux action types you want to filter for, variadic.
 */
function ofType() {
    var types = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        types[_i] = arguments[_i];
    }
    return operators_1.filter(function (action) {
        var type = action.type;
        var len = types.length;
        if (len === 1) {
            return keyHasType(type, types[0]);
        }
        else {
            for (var i = 0; i < len; i++) {
                if (keyHasType(type, types[i])) {
                    return true;
                }
            }
        }
        return false;
    });
}
exports.ofType = ofType;
