import { filter } from 'rxjs/operators';
const keyHasType = (type, key) => {
    return type === key || (typeof key === 'function' && type === key.toString());
};
/**
 * Inferring the types of this is a bit challenging, and only works in newer
 * versions of TypeScript.
 *
 * @param ...types One or more Redux action types you want to filter for, variadic.
 */
export function ofType(...types) {
    return filter((action) => {
        const { type } = action;
        const len = types.length;
        if (len === 1) {
            return keyHasType(type, types[0]);
        }
        else {
            for (let i = 0; i < len; i++) {
                if (keyHasType(type, types[i])) {
                    return true;
                }
            }
        }
        return false;
    });
}
